/*

macdns.h

Header file for asynchronous DNS lookups on the MAC

*/

#ifndef macdns_h
#define macdns_h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <events.h>
#include "WinSock.h"
#include "nmmessage.h"
#define DNR_DONE 1001
#define TCP_DEFAULT_TIMEOUT (30*60)

/* prototypes */
struct hostent* macgethostbyname(const char *HostName);
struct hostent* macgethostbyaddr(const char *addr, int len, int type);

#endif /*macdns_h*/